/* tslint:disable */
/* eslint-disable */
export function color_categories(): any;
export function search_color_cards(tag: string, category?: string | null): any;
export function generate_material_design_3_scheme(source_color: string, error_color: string, custom_colors: any): any;
export function generate_material_design_2_scheme(primary_color: string, secondary_color: string, error_color: string, custom_colors: any): any;
export function generate_q_scheme_automatically(primary_color: string, danger_color: string, success_color: string, warning_color: string, info_color: string, fg_color: string, bg_color: string, setting: SchemeSetting): any;
export function generate_q_scheme_manually(primary_color: string, secondary_color: string | null | undefined, tertiary_color: string | null | undefined, accent_color: string | null | undefined, danger_color: string, success_color: string, warning_color: string, info_color: string, fg_color: string, bg_color: string, setting: SchemeSetting): any;
export function generate_swatch_scheme(colors: SwatchEntry[], setting: SwatchSchemeSetting): any;
export function differ_in_rgb(color: string, other: string): RGBDifference;
export function relative_differ_in_rgb(color: string, other: string): RGBDifference;
export function differ_in_hsl(color: string, other: string): HSLDifference;
export function relative_differ_in_hsl(color: string, other: string): HSLDifference;
export function differ_in_hct(color: string, other: string): HctDiffference;
export function relative_differ_in_hct(color: string, other: string): HctDiffference;
export function differ_in_oklch(color: string, other: string): OklchDifference;
export function relative_differ_in_oklch(color: string, other: string): OklchDifference;
export function tint_scale(basic_color: string, mixed_color: string): MixReversing;
export function shade_scale(basic_color: string, mixed_color: string): MixReversing;
export function lighten(color: string, percent: number): string;
export function lighten_absolute(color: string, value: number): string;
export function darken(color: string, percent: number): string;
export function darken_absolute(color: string, value: number): string;
export function mix(color1: string, color2: string, percent: number): string;
export function tint(color: string, percent: number): string;
export function shade(color: string, percent: number): string;
export function shift_hue(color: string, degree: number): string;
export function analogous_30(color: string): string[];
export function analogous_60(color: string): string[];
export function complementary(color: string): string;
export function split_complementary(color: string): string[];
export function tetradic(color: string): string[];
export function triadic(color: string): string[];
export function represent_rgb(color: string): Uint8Array;
export function rgb_to_hex(r: number, g: number, b: number): string;
export function represent_hsl(color: string): Float32Array;
export function hsl_to_hex(h: number, s: number, l: number): string;
export function represent_lab(color: string): Float32Array;
export function lab_to_hex(l: number, a: number, b: number): string;
export function represent_oklch(color: string): Float32Array;
export function oklch_to_hex(l: number, c: number, h: number): string;
export function represent_hct(color: string): Float32Array;
export function hct_to_hex(hue: number, chroma: number, tone: number): string;
export function wacg_relative_contrast(fg_color: string, bg_color: string): number;
export function generate_palette_from_color(reference_color: string, swatch_amount: number, minimum_lightness: number, maximum_lightness: number, use_reference_color?: boolean | null, reference_color_bias?: number | null): string[];
export function swatch_scheme_default_settings(): SwatchSchemeSetting;
export function series(color: string, expand_amount: number, step: number): string[];
export function tonal_lighten_series(color: string, expand_amount: number, step: number): string[];
export function tonal_darken_series(color: string, expand_amount: number, step: number): string[];
export function q_scheme_color_expanding_methods(): any;
export function q_scheme_wacg_settings(): any;
export function q_scheme_default_settings(): SchemeSetting;
export enum ColorExpand {
  Complementary = 0,
  Analogous = 1,
  AnalogousAndComplementary = 2,
  Triadic = 3,
  SplitComplementary = 4,
  Tetradic = 5,
  Square = 6,
}
export enum WACGSetting {
  Fixed = 0,
  AutomaticAA = 1,
  AutomaticAAA = 2,
  HighContrast = 3,
}
export class ColorShifting {
  free(): void;
  constructor(chroma: number, lightness: number);
  toJsValue(): any;
  chroma: number;
  lightness: number;
}
export class Differ {
  private constructor();
  free(): void;
  delta: number;
  percent: number;
}
export class HSLDifference {
  private constructor();
  free(): void;
  hue: Differ;
  saturation: Differ;
  lightness: Differ;
}
export class HctDiffference {
  private constructor();
  free(): void;
  hue: Differ;
  chroma: Differ;
  lightness: Differ;
}
export class MixReversing {
  private constructor();
  free(): void;
  r_factor: number;
  g_factor: number;
  b_factor: number;
  average: number;
}
export class OklchDifference {
  private constructor();
  free(): void;
  hue: Differ;
  chroma: Differ;
  lightness: Differ;
}
export class RGBDifference {
  private constructor();
  free(): void;
  r: Differ;
  g: Differ;
  b: Differ;
}
export class SchemeSetting {
  free(): void;
  constructor(hover: ColorShifting, active: ColorShifting, focus: ColorShifting, disabled: ColorShifting, dark_convert: ColorShifting, expand_method: ColorExpand, wacg_follows: WACGSetting);
  toJsValue(): any;
  hover: ColorShifting;
  active: ColorShifting;
  focus: ColorShifting;
  disabled: ColorShifting;
  dark_convert: ColorShifting;
  expand_method: ColorExpand;
  wacg_follows: WACGSetting;
}
export class SwatchEntry {
  free(): void;
  constructor(name: string, color: string);
  toJsValue(): any;
  name: string;
  color: string;
}
export class SwatchSchemeSetting {
  free(): void;
  constructor(amount: number, min_lightness: number, max_lightness: number, include_primary: boolean, dark_convert: ColorShifting);
  toJsValue(): any;
  amount: number;
  min_lightness: number;
  max_lightness: number;
  include_primary: boolean;
  dark_convert: ColorShifting;
}

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly color_categories: () => [number, number, number];
  readonly search_color_cards: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly __wbg_colorshifting_free: (a: number, b: number) => void;
  readonly __wbg_get_colorshifting_chroma: (a: number) => number;
  readonly __wbg_set_colorshifting_chroma: (a: number, b: number) => void;
  readonly __wbg_get_colorshifting_lightness: (a: number) => number;
  readonly __wbg_set_colorshifting_lightness: (a: number, b: number) => void;
  readonly colorshifting_new: (a: number, b: number) => number;
  readonly colorshifting_toJsValue: (a: number) => [number, number, number];
  readonly __wbg_schemesetting_free: (a: number, b: number) => void;
  readonly __wbg_get_schemesetting_hover: (a: number) => number;
  readonly __wbg_set_schemesetting_hover: (a: number, b: number) => void;
  readonly __wbg_get_schemesetting_active: (a: number) => number;
  readonly __wbg_set_schemesetting_active: (a: number, b: number) => void;
  readonly __wbg_get_schemesetting_focus: (a: number) => number;
  readonly __wbg_set_schemesetting_focus: (a: number, b: number) => void;
  readonly __wbg_get_schemesetting_disabled: (a: number) => number;
  readonly __wbg_set_schemesetting_disabled: (a: number, b: number) => void;
  readonly __wbg_get_schemesetting_dark_convert: (a: number) => number;
  readonly __wbg_set_schemesetting_dark_convert: (a: number, b: number) => void;
  readonly __wbg_get_schemesetting_expand_method: (a: number) => number;
  readonly __wbg_set_schemesetting_expand_method: (a: number, b: number) => void;
  readonly __wbg_get_schemesetting_wacg_follows: (a: number) => number;
  readonly __wbg_set_schemesetting_wacg_follows: (a: number, b: number) => void;
  readonly schemesetting_new: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => number;
  readonly schemesetting_toJsValue: (a: number) => [number, number, number];
  readonly generate_material_design_3_scheme: (a: number, b: number, c: number, d: number, e: any) => [number, number, number];
  readonly generate_material_design_2_scheme: (a: number, b: number, c: number, d: number, e: number, f: number, g: any) => [number, number, number];
  readonly generate_q_scheme_automatically: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number, n: number, o: number) => [number, number, number];
  readonly generate_q_scheme_manually: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number, n: number, o: number, p: number, q: number, r: number, s: number, t: number, u: number) => [number, number, number];
  readonly generate_swatch_scheme: (a: number, b: number, c: number) => [number, number, number];
  readonly differ_in_rgb: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly relative_differ_in_rgb: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly differ_in_hsl: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly relative_differ_in_hsl: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly differ_in_hct: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly relative_differ_in_hct: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly differ_in_oklch: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly relative_differ_in_oklch: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly tint_scale: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly shade_scale: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly __wbg_oklchdifference_free: (a: number, b: number) => void;
  readonly __wbg_get_oklchdifference_hue: (a: number) => number;
  readonly __wbg_set_oklchdifference_hue: (a: number, b: number) => void;
  readonly __wbg_get_oklchdifference_chroma: (a: number) => number;
  readonly __wbg_set_oklchdifference_chroma: (a: number, b: number) => void;
  readonly __wbg_get_oklchdifference_lightness: (a: number) => number;
  readonly __wbg_set_oklchdifference_lightness: (a: number, b: number) => void;
  readonly lighten: (a: number, b: number, c: number) => [number, number, number, number];
  readonly lighten_absolute: (a: number, b: number, c: number) => [number, number, number, number];
  readonly darken: (a: number, b: number, c: number) => [number, number, number, number];
  readonly darken_absolute: (a: number, b: number, c: number) => [number, number, number, number];
  readonly mix: (a: number, b: number, c: number, d: number, e: number) => [number, number, number, number];
  readonly tint: (a: number, b: number, c: number) => [number, number, number, number];
  readonly shade: (a: number, b: number, c: number) => [number, number, number, number];
  readonly __wbg_hctdiffference_free: (a: number, b: number) => void;
  readonly __wbg_get_hctdiffference_hue: (a: number) => number;
  readonly __wbg_set_hctdiffference_hue: (a: number, b: number) => void;
  readonly __wbg_get_hctdiffference_chroma: (a: number) => number;
  readonly __wbg_set_hctdiffference_chroma: (a: number, b: number) => void;
  readonly __wbg_get_hctdiffference_lightness: (a: number) => number;
  readonly __wbg_set_hctdiffference_lightness: (a: number, b: number) => void;
  readonly __wbg_differ_free: (a: number, b: number) => void;
  readonly __wbg_get_differ_delta: (a: number) => number;
  readonly __wbg_set_differ_delta: (a: number, b: number) => void;
  readonly __wbg_get_differ_percent: (a: number) => number;
  readonly __wbg_set_differ_percent: (a: number, b: number) => void;
  readonly shift_hue: (a: number, b: number, c: number) => [number, number, number, number];
  readonly analogous_30: (a: number, b: number) => [number, number, number, number];
  readonly analogous_60: (a: number, b: number) => [number, number, number, number];
  readonly complementary: (a: number, b: number) => [number, number, number, number];
  readonly split_complementary: (a: number, b: number) => [number, number, number, number];
  readonly tetradic: (a: number, b: number) => [number, number, number, number];
  readonly triadic: (a: number, b: number) => [number, number, number, number];
  readonly represent_rgb: (a: number, b: number) => [number, number, number, number];
  readonly rgb_to_hex: (a: number, b: number, c: number) => [number, number, number, number];
  readonly represent_hsl: (a: number, b: number) => [number, number, number, number];
  readonly hsl_to_hex: (a: number, b: number, c: number) => [number, number, number, number];
  readonly represent_lab: (a: number, b: number) => [number, number, number, number];
  readonly lab_to_hex: (a: number, b: number, c: number) => [number, number, number, number];
  readonly represent_oklch: (a: number, b: number) => [number, number, number, number];
  readonly oklch_to_hex: (a: number, b: number, c: number) => [number, number, number, number];
  readonly represent_hct: (a: number, b: number) => [number, number, number, number];
  readonly hct_to_hex: (a: number, b: number, c: number) => [number, number, number, number];
  readonly wacg_relative_contrast: (a: number, b: number, c: number, d: number) => [number, number, number];
  readonly __wbg_hsldifference_free: (a: number, b: number) => void;
  readonly __wbg_get_hsldifference_hue: (a: number) => number;
  readonly __wbg_set_hsldifference_hue: (a: number, b: number) => void;
  readonly __wbg_get_hsldifference_saturation: (a: number) => number;
  readonly __wbg_set_hsldifference_saturation: (a: number, b: number) => void;
  readonly __wbg_get_hsldifference_lightness: (a: number) => number;
  readonly __wbg_set_hsldifference_lightness: (a: number, b: number) => void;
  readonly __wbg_mixreversing_free: (a: number, b: number) => void;
  readonly __wbg_get_mixreversing_r_factor: (a: number) => number;
  readonly __wbg_set_mixreversing_r_factor: (a: number, b: number) => void;
  readonly __wbg_get_mixreversing_g_factor: (a: number) => number;
  readonly __wbg_set_mixreversing_g_factor: (a: number, b: number) => void;
  readonly __wbg_get_mixreversing_b_factor: (a: number) => number;
  readonly __wbg_set_mixreversing_b_factor: (a: number, b: number) => void;
  readonly __wbg_get_mixreversing_average: (a: number) => number;
  readonly __wbg_set_mixreversing_average: (a: number, b: number) => void;
  readonly __wbg_rgbdifference_free: (a: number, b: number) => void;
  readonly __wbg_get_rgbdifference_r: (a: number) => number;
  readonly __wbg_set_rgbdifference_r: (a: number, b: number) => void;
  readonly __wbg_get_rgbdifference_g: (a: number) => number;
  readonly __wbg_set_rgbdifference_g: (a: number, b: number) => void;
  readonly __wbg_get_rgbdifference_b: (a: number) => number;
  readonly __wbg_set_rgbdifference_b: (a: number, b: number) => void;
  readonly generate_palette_from_color: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => [number, number, number, number];
  readonly __wbg_swatchschemesetting_free: (a: number, b: number) => void;
  readonly __wbg_get_swatchschemesetting_amount: (a: number) => number;
  readonly __wbg_set_swatchschemesetting_amount: (a: number, b: number) => void;
  readonly __wbg_get_swatchschemesetting_min_lightness: (a: number) => number;
  readonly __wbg_set_swatchschemesetting_min_lightness: (a: number, b: number) => void;
  readonly __wbg_get_swatchschemesetting_max_lightness: (a: number) => number;
  readonly __wbg_set_swatchschemesetting_max_lightness: (a: number, b: number) => void;
  readonly __wbg_get_swatchschemesetting_include_primary: (a: number) => number;
  readonly __wbg_set_swatchschemesetting_include_primary: (a: number, b: number) => void;
  readonly __wbg_get_swatchschemesetting_dark_convert: (a: number) => number;
  readonly __wbg_set_swatchschemesetting_dark_convert: (a: number, b: number) => void;
  readonly swatchschemesetting_new: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly swatchschemesetting_toJsValue: (a: number) => [number, number, number];
  readonly __wbg_swatchentry_free: (a: number, b: number) => void;
  readonly __wbg_get_swatchentry_name: (a: number) => [number, number];
  readonly __wbg_set_swatchentry_name: (a: number, b: number, c: number) => void;
  readonly __wbg_get_swatchentry_color: (a: number) => [number, number];
  readonly __wbg_set_swatchentry_color: (a: number, b: number, c: number) => void;
  readonly swatchentry_new: (a: number, b: number, c: number, d: number) => number;
  readonly swatchentry_toJsValue: (a: number) => [number, number, number];
  readonly swatch_scheme_default_settings: () => number;
  readonly series: (a: number, b: number, c: number, d: number) => [number, number, number, number];
  readonly tonal_lighten_series: (a: number, b: number, c: number, d: number) => [number, number, number, number];
  readonly tonal_darken_series: (a: number, b: number, c: number, d: number) => [number, number, number, number];
  readonly q_scheme_color_expanding_methods: () => [number, number, number];
  readonly q_scheme_wacg_settings: () => [number, number, number];
  readonly q_scheme_default_settings: () => number;
  readonly __wbindgen_malloc: (a: number, b: number) => number;
  readonly __wbindgen_realloc: (a: number, b: number, c: number, d: number) => number;
  readonly __wbindgen_exn_store: (a: number) => void;
  readonly __externref_table_alloc: () => number;
  readonly __wbindgen_export_4: WebAssembly.Table;
  readonly __externref_table_dealloc: (a: number) => void;
  readonly __wbindgen_free: (a: number, b: number, c: number) => void;
  readonly __externref_drop_slice: (a: number, b: number) => void;
  readonly __wbindgen_start: () => void;
}

export type SyncInitInput = BufferSource | WebAssembly.Module;
/**
* Instantiates the given `module`, which can either be bytes or
* a precompiled `WebAssembly.Module`.
*
* @param {{ module: SyncInitInput }} module - Passing `SyncInitInput` directly is deprecated.
*
* @returns {InitOutput}
*/
export function initSync(module: { module: SyncInitInput } | SyncInitInput): InitOutput;

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {{ module_or_path: InitInput | Promise<InitInput> }} module_or_path - Passing `InitInput` directly is deprecated.
*
* @returns {Promise<InitOutput>}
*/
export default function __wbg_init (module_or_path?: { module_or_path: InitInput | Promise<InitInput> } | InitInput | Promise<InitInput>): Promise<InitOutput>;
